#!/bin/bash
  
clear
echo "******************************************************"
echo "*               Pysycache installation               *"
echo "******************************************************"

PREFIX=/usr
SCOREDIR=/var/games


#################################################################
# DON'T EDIT AFTER THESE LINES 
#################################################################


if [ $* ]
then PREFIX=$*
fi
echo ""
echo "Used PREFIX for installation is : $PREFIX"


BINDIR=$PREFIX/games
DOCDIR=$PREFIX/share/doc/pysycache
EXECDIR=$PREFIX/bin
MANDIR=$PREFIX/man/man1
SHAREDIR=$PREFIX/share/pysycache


OLDCPDIR=$PREFIX/games/pysycache


#----------------------- creation des repertoires ---------------------------

echo ""
echo "Making directories for Pysycache..."
mkdir -vp $BINDIR
mkdir -vp $DOCDIR
mkdir -vp $EXECDIR
mkdir -vp $MANDIR
mkdir -vp $SHAREDIR




#----------------------- recherche de l'utilisateur ---------------------------
set -e
CWD=`pwd`
USERID=`id | sed -e 's/).*//; s/^.*(//;'`
if [ "$USERID" != "root" ]; then
    echo ""
    echo "Be aware, you are not root... "
    echo "Maybe you have not correct rights to install pysycache ! "
fi



echo ""
echo "Copy of required files..."
cp -rf pysycache/* $SHAREDIR

touch $BINDIR/pysycache
echo "#!/bin/bash" >  $BINDIR/pysycache
echo "cd" >>  $BINDIR/pysycache
echo "python $SHAREDIR/pysycache.py \" \" \$*  " >>  $BINDIR/pysycache
chmod +x $BINDIR/pysycache

                                                      
echo ""
echo "Copy of documentation..."
cp -rf pysycache-doc/* $DOCDIR

echo ""
echo "Copy of menus languages..."
cp -rf pysycache-lang/* $SHAREDIR/lang


echo ""
echo "Copy menus entry for PySyCache..."
echo "todo for the final release ;-)"







